package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesCellEquipContext;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesEquipLogDispatchContext;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentLog;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentVariable;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentVariableCfg;
import io.swagger.annotations.ApiOperation;

import java.util.List;

public interface IMesEquipmentLogExtService {

    @ApiOperation(value = "根据设备ID 查询设备ID分表所有采集数据")
    List<MesEquipmentLog> getEquipmentLogList(String organizeCode, Integer equipId);

    @ApiOperation(value = "根据设备ID,是否常变值状态,OPC注册ID集合 查询设备ID分表采集数据")
    List<MesEquipmentLog> getEquipmentLogList(String organizeCode, Integer equipId, Integer needNewValue, List<Long> clientHandleList);

    @ApiOperation(value = "根据设备ID,OPC注册ID集合 修改设备ID分表采集数据的状态")
    void updateEquipmentLogList(String organizeCode, Integer equipId, List<Long> clientHandleList);

    @ApiOperation(value = "获取设备数据变量对应的采集数据")
    MesEquipLogDispatchContext doHandleEquipmentLogList(MesCellEquipContext cellEquipContext, List<MesEquipmentVariable> equipmentVariableList, List<MesEquipmentVariableCfg> equipmentVariableCfgList);

    @ApiOperation(value = "验证设备通信质量")
    Boolean checkEquipQuality(Integer quality);

}
