package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProduceSnExtService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn;
import cn.estsh.i3plus.pojo.mes.repository.MesProduceSnRepository;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;

@Slf4j
@Service
public class MesProduceSnExtService implements IMesProduceSnExtService {

    @Autowired
    private MesProduceSnRepository produceSnRepository;

    //根据零件条码查询零件条码信息
    @Override
    public List<MesProduceSn> getProduceSnList(String organizeCode, List<String> productSnList) {

        if (StringUtils.isEmpty(organizeCode) || CollectionUtils.isEmpty(productSnList)) return null;

        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        if (productSnList.size() == 1) DdlPreparedPack.getStringEqualPack(productSnList.get(0), MesPcnExtConstWords.PRODUCT_SN, packBean);
        else DdlPreparedPack.getInPackList(productSnList.stream().filter(o -> StringUtils.isEmpty(o)).distinct().collect(Collectors.toList()), MesPcnExtConstWords.PRODUCT_SN, packBean);
        //根据创建时间倒叙查询零件条码
        DdlPreparedPack.getOrderByPack(new Object[]{CommonEnumUtil.ASC_OR_DESC.DESC.getValue()}, new String[]{MesPcnExtConstWords.CREATE_DATE_TIME}, packBean);

        return distinctProduceSnList(produceSnRepository.findByHqlWhere(packBean));
    }

    private List<MesProduceSn> distinctProduceSnList(List<MesProduceSn> produceSnDataList) {
        return CollectionUtils.isEmpty(produceSnDataList) ? null :
                produceSnDataList.stream().filter(o -> null != o).distinct().collect(Collectors.collectingAndThen(Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(MesProduceSn::getProductSn))), ArrayList::new));
    }

    //根据零件条码查询零件条码信息
    @Override
    public Map<String, MesProduceSn> getProduceSnMap(String organizeCode, List<String> productSnList) {
        return groupProduceSnList(getProduceSnList(organizeCode, productSnList));
    }

    private Map<String, MesProduceSn> groupProduceSnList(List<MesProduceSn> produceSnDataList) {
        return CollectionUtils.isEmpty(produceSnDataList) ? null : produceSnDataList.stream().filter(o -> null != o).collect(Collectors.toMap(MesProduceSn::getProductSn, o -> o));
    }

}
