package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentVariable;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.util.CollectionUtils;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * 生产过程上下文对象-数据变量接口逻辑信息
 */
@Data
public class MesEquipVariableCfgCollectContext implements Serializable {

    private static final long serialVersionUID = 4521711037005858586L;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("变量配置类型")
    private String variableCfgType;

    @ApiParam("变量类别")
    private String variableCategory;

    @ApiParam("二级变量")
    private String categoryLevelTwo;

    @ApiParam("规则类别")
    private String ruleCategory;

    @ApiParam("参考值")
    private String value;

    @ApiParam("是否常变值")
    private Integer needNewValue;

    @ApiParam("数据变量集合")
    private List<MesEquipVariableCollectContext> equipVariableCollectContextList;

    @ApiParam("数据变量OPC注册ID集合")
    private List<Long> clientHandleList;

    public MesEquipVariableCfgCollectContext equipVariableCollectContextList(List<MesEquipmentVariable> equipVariableList) {
        if (CollectionUtils.isEmpty(equipVariableList)) return this;
        this.equipVariableCollectContextList = new ArrayList<>();
        this.clientHandleList = new ArrayList<>();
        for (MesEquipmentVariable equipmentVariable : equipVariableList) {
            if (null == equipmentVariable) continue;
            MesEquipVariableCollectContext equipVariableCollectContext = new MesEquipVariableCollectContext(equipmentVariable.getId());
            BeanUtils.copyProperties(equipmentVariable, equipVariableCollectContext);
            equipVariableCollectContextList.add(equipVariableCollectContext);
            clientHandleList.add(Long.valueOf(equipmentVariable.getClientHandle().toString()));
        }
        return this;
    }
}
