package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import cn.estsh.i3plus.pojo.mes.bean.MesMouldMultiCavity;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.beans.BeanUtils;

import java.io.Serializable;

/**
 * 生产过程上下文对象-产出零件信息
 */
@Data
public class MesProductionPartContext implements Serializable {

    private static final long serialVersionUID = 5562937531822977296L;

    @ApiParam(name = "数据关联键  排序:生产工单号  非排序:snowflakeId")
    private String foreignKey;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("生产工单号")
    private String workOrderNo;

    @ApiParam("设备代码")
    private String equipmentCode;

    @ApiParam("设备名称")
    private String equipmentName;

    @ApiParam("零件号")
    private String partNo;

    @ApiParam("零件名称")
    private String partName;

    @ApiParam("模具代码")
    private String mouldNo;

    public MesProductionPartContext copyMouldMultiCavity(MesMouldMultiCavity mouldMultiCavity) {
        BeanUtils.copyProperties(mouldMultiCavity, this);
        this.foreignKey = mouldMultiCavity.getId().toString();
        return this;
    }

    //-------以下场景预留未开发-------
    public MesProductionPartContext copyWorkOrder(String workOrderNo) {
        this.foreignKey = workOrderNo + "腔顺序号";
        return this;
    }

    public MesProductionPartContext copyPartNo(String partNo) {
        this.foreignKey = partNo + "腔顺序号";
        return this;
    }

}
